/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/

#line 1 "makedict.opt"
/* This file is part of Dico.                  -* c -*-
   Copyright (C) 1998-2000, 2008 Sergey Poznyakoff

   Dico is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Dico is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Dico.  If not, see <http://www.gnu.org/licenses/>. */

#include <makedict.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <getopt.h>
#include <gettext.h>
#include <dico.h>
#include <stdarg.h>
#include <limits.h>

#line 28 "makedict.opt"

#line 28
void print_help(void);
#line 28
void print_usage(void);
#line 66 "makedict.opt"

#line 66
/* Option codes */
#line 66
enum {
#line 66
	_OPTION_INIT=255,
#line 66
	#line 66 "makedict.opt"

#line 66
	OPTION_USAGE,
#line 66 "makedict.opt"

#line 66
	OPTION_VERSION,

#line 66 "makedict.opt"
	MAX_OPTION
#line 66
};
#line 66
static struct option long_options[] = {
#line 66
	#line 31 "makedict.opt"

#line 31
	{ "compile", no_argument, 0, 'c' },
#line 36 "makedict.opt"

#line 36
	{ "dictionary-directory", required_argument, 0, 'd' },
#line 42 "makedict.opt"

#line 42
	{ "kanjidic", required_argument, 0, 'k' },
#line 48 "makedict.opt"

#line 48
	{ "edict", required_argument, 0, 'e' },
#line 54 "makedict.opt"

#line 54
	{ "output-directory", required_argument, 0, 'o' },
#line 60 "makedict.opt"

#line 60
	{ "verbose", no_argument, 0, 'v' },
#line 66 "makedict.opt"

#line 66
	{ "help", no_argument, 0, 'h' },
#line 66 "makedict.opt"

#line 66
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 66 "makedict.opt"

#line 66
	{ "version", no_argument, 0, OPTION_VERSION },

#line 66 "makedict.opt"
	{0, 0, 0, 0}
#line 66
};
#line 66
static struct opthelp {
#line 66
        const char *opt;
#line 66
        const char *arg;
#line 66
        int is_optional;
#line 66
        const char *descr;
#line 66
} opthelp[] = {
#line 66
	#line 31 "makedict.opt"

#line 31
	{ "-c, --compile", NULL, 0, N_("Compile dictionaries using default values.") },
#line 36 "makedict.opt"

#line 36
	{ "-d, --dictionary-directory", N_("DIR"), 0, N_("Set input dictionary path.") },
#line 42 "makedict.opt"

#line 42
	{ "-k, --kanjidic", N_("FILE"), 0, N_("Set name for kanjidic file.") },
#line 48 "makedict.opt"

#line 48
	{ "-e, --edict", N_("FILE"), 0, N_("Set name for edict file.") },
#line 60 "makedict.opt"

#line 60
	{ "-v, --verbose", NULL, 0, N_("Increase verbosity level.") },
#line 66 "makedict.opt"

#line 66
	{ NULL, NULL, 0, N_("Other options") },
#line 66 "makedict.opt"

#line 66
	{ "-h, --help", NULL, 0, N_("Give this help list") },
#line 66 "makedict.opt"

#line 66
	{ "--usage", NULL, 0, N_("Give a short usage message") },
#line 66 "makedict.opt"

#line 66
	{ "--version", NULL, 0, N_("Print program version") },

#line 66 "makedict.opt"
};
#line 28 "makedict.opt"

#line 28
const char *program_version = "makedict" " (" PACKAGE_STRING ")";
#line 28
static char doc[] = N_("Create binary dictionary for use with gjdictd.");
#line 28
static char args_doc[] = N_("");
#line 28
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 28
		    
#line 28
#define DESCRCOLUMN 30
#line 28
#define RMARGIN 79
#line 28
#define GROUPCOLUMN 2
#line 28
#define USAGECOLUMN 13
#line 28
		    
#line 28
static void
#line 28
indent (size_t start, size_t col)
#line 28
{
#line 28
  for (; start < col; start++)
#line 28
    putchar (' ');
#line 28
}
#line 28
		    
#line 28
static void
#line 28
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 28
{
#line 28
  while (*descr)
#line 28
    {
#line 28
      size_t s = 0;
#line 28
      size_t i;
#line 28
      size_t width = rmargin - lmargin;
#line 28

#line 28
      for (i = 0; ; i++)
#line 28
	{
#line 28
	  if (descr[i] == 0 || isspace (descr[i]))
#line 28
	    {
#line 28
	      if (i > width)
#line 28
		break;
#line 28
	      s = i;
#line 28
	      if (descr[i] == 0)
#line 28
		break;
#line 28
	    }
#line 28
	}
#line 28
      printf ("%*.*s\n", s, s, descr);
#line 28
      descr += s;
#line 28
      if (*descr)
#line 28
	{
#line 28
	  indent (0, lmargin);
#line 28
	  descr++;
#line 28
	}
#line 28
    }
#line 28
}
#line 28

#line 28
void
#line 28
print_help(void)
#line 28
{
#line 28
  unsigned i;
#line 28
  
#line 28
  printf ("%s %s [%s]... %s\n", _("Usage:"), "makedict", _("OPTION"),
#line 28
	  gettext (args_doc)); 
#line 28
  if (doc && doc[0])
#line 28
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 28
  putchar ('\n');
#line 28

#line 28
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 28
    {
#line 28
      unsigned n;
#line 28
      if (opthelp[i].opt)
#line 28
	{
#line 28
	  n = printf ("  %s", opthelp[i].opt);
#line 28
	  if (opthelp[i].arg)
#line 28
	    {
#line 28
	      char *cb, *ce;
#line 28
	      if (strlen (opthelp[i].opt) == 2)
#line 28
		{
#line 28
		  if (!opthelp[i].is_optional)
#line 28
		    {
#line 28
		      putchar (' ');
#line 28
		      n++;
#line 28
		    }
#line 28
		}
#line 28
	      else
#line 28
		{
#line 28
		  putchar ('=');
#line 28
		  n++;
#line 28
		}
#line 28
	      if (opthelp[i].is_optional)
#line 28
		{
#line 28
		  cb = "[";
#line 28
		  ce = "]";
#line 28
		}
#line 28
	      else
#line 28
		cb = ce = "";
#line 28
	      n += printf ("%s%s%s", cb, gettext (opthelp[i].arg), ce);
#line 28
	    }
#line 28
	  if (n >= DESCRCOLUMN)
#line 28
	    {
#line 28
	      putchar ('\n');
#line 28
	      n = 0;
#line 28
	    }
#line 28
	  indent (n, DESCRCOLUMN);
#line 28
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 28
	}
#line 28
      else
#line 28
	{
#line 28
	  putchar ('\n');
#line 28
	  indent (0, GROUPCOLUMN);
#line 28
	  print_option_descr (gettext (opthelp[i].descr),
#line 28
			      GROUPCOLUMN, RMARGIN);
#line 28
	  putchar ('\n');
#line 28
	}
#line 28
    }
#line 28
  
#line 28
  putchar ('\n');
#line 28
  print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 28
  putchar ('\n');
#line 28
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 28
}
#line 28

#line 28
void
#line 28
print_usage(void)
#line 28
{
#line 28
  unsigned i;
#line 28
  int f = 0;
#line 28
  unsigned n;
#line 28
  char buf[RMARGIN+1];
#line 28

#line 28
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 28
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 28

#line 28
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "makedict");
#line 28

#line 28
  /* Print a list of short options without arguments. */
#line 28
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 28
    {
#line 28
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 28
	  && opthelp[i].arg == NULL)
#line 28
	{
#line 28
	  if (f == 0)
#line 28
	    {
#line 28
	      ADDC('[');
#line 28
	      ADDC('-');
#line 28
	      f = 1;
#line 28
	    }
#line 28
	  ADDC(opthelp[i].opt[1]);
#line 28
	}
#line 28
    }
#line 28
  if (f)
#line 28
    ADDC(']');
#line 28

#line 28
  /* Print a list of short options with arguments. */
#line 28
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 28
    {
#line 28
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 28
	  && opthelp[i].arg)
#line 28
	{
#line 28
	  size_t len = 5 
#line 28
	                + strlen (opthelp[i].arg)
#line 28
			   + (opthelp[i].is_optional ? 2 : 1);
#line 28
	  if (n + len > RMARGIN) FLUSH;
#line 28
	  buf[n++] = ' '; 
#line 28
	  buf[n++] = '['; 
#line 28
	  buf[n++] = '-';
#line 28
	  buf[n++] = opthelp[i].opt[1];
#line 28
	  if (opthelp[i].is_optional)
#line 28
	    {
#line 28
	      buf[n++] = '[';
#line 28
	      strcpy (&buf[n], opthelp[i].arg);
#line 28
	      n += strlen (opthelp[i].arg);
#line 28
	      buf[n++] = ']';
#line 28
	    }
#line 28
	  else
#line 28
	    {
#line 28
	      buf[n++] = ' ';
#line 28
	      strcpy (&buf[n], opthelp[i].arg);
#line 28
	      n += strlen (opthelp[i].arg);
#line 28
	    }
#line 28
	  buf[n++] = ']';
#line 28
	}
#line 28
    }
#line 28

#line 28
  /* Print a list of long options */
#line 28
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 28
    {
#line 28
      if (opthelp[i].opt && opthelp[i].descr)
#line 28
	{
#line 28
	  size_t len;
#line 28
	  const char *longopt;
#line 28

#line 28
	  if (opthelp[i].opt[1] == '-')
#line 28
	    longopt = opthelp[i].opt;
#line 28
	  else if (opthelp[i].opt[2] == ',')
#line 28
	    longopt = opthelp[i].opt + 4;
#line 28
	  else
#line 28
	    continue;
#line 28

#line 28
	  len = 3 + strlen (longopt)
#line 28
	          + (opthelp[i].arg ? 1 + strlen (opthelp[i].arg)
#line 28
		      + (opthelp[i].is_optional ? 2 : 0) : 0);
#line 28
	  if (n + len > RMARGIN) FLUSH;
#line 28
	  buf[n++] = ' '; 
#line 28
	  buf[n++] = '['; 
#line 28
	  strcpy (&buf[n], longopt);
#line 28
	  n += strlen (longopt);
#line 28
	  if (opthelp[i].arg)
#line 28
	    {
#line 28
	      buf[n++] = '=';
#line 28
	      if (opthelp[i].is_optional)
#line 28
		{
#line 28
		  buf[n++] = '[';
#line 28
		  strcpy (&buf[n], opthelp[i].arg);
#line 28
		  n += strlen (opthelp[i].arg);
#line 28
		  buf[n++] = ']';
#line 28
		}
#line 28
	      else
#line 28
		{
#line 28
		  strcpy (&buf[n], opthelp[i].arg);
#line 28
		  n += strlen (opthelp[i].arg);
#line 28
		}
#line 28
	    }
#line 28
	  buf[n++] = ']';
#line 28
	}
#line 28
    }
#line 28
  FLUSH;
#line 28
  
#line 28
}
#line 28

#line 28
const char version_etc_copyright[] =
#line 28
  /* Do *not* mark this string for translation.  %s is a copyright
     symbol suitable for this locale, and %d is the copyright
     year.  */
#line 28
  "Copyright %s 2005, 2006, 2007, 2008 Sergey Poznyakoff";
#line 28

#line 28
static void
#line 28
print_version(const char *program_version, FILE *stream)
#line 28
{
#line 28
	fprintf (stream, "%s\n", program_version);
#line 28
	/* TRANSLATORS: Translate "(C)" to the copyright symbol
	   (C-in-a-circle), if this symbol is available in the user's
	   locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 28
	fprintf (stream, version_etc_copyright, _("(C)"));
#line 28

#line 28
	fputs (_("\nLicense GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 28
	       stream);
#line 28
	
#line 28
	/* TRANSLATORS: %s denotes an author name.  */
#line 28
	fprintf (stream, _("Written by %s.\n"), "Sergey Poznyakoff");
#line 28
}
#line 28

#line 66 "makedict.opt"

#line 66


void
get_options (int argc, char *argv[])
{
    
#line 71
 {
#line 71
  int c;
#line 71
  
#line 71
  while ((c = getopt_long(argc, argv, "cd:k:e:o:vh",
#line 71
                          long_options, NULL)) != EOF)
#line 71
    {
#line 71
      switch (c)
#line 71
        {
#line 71
        default:
#line 71
	   exit(1);
#line 71
	#line 33 "makedict.opt"
	 case 'c':
#line 33
          {
#line 33


#line 34
             break;
#line 34
          }
#line 38 "makedict.opt"
	 case 'd':
#line 38
          {
#line 38

   dictdir = optarg;

#line 40
             break;
#line 40
          }
#line 44 "makedict.opt"
	 case 'k':
#line 44
          {
#line 44

   kanjidict = optarg;

#line 46
             break;
#line 46
          }
#line 50 "makedict.opt"
	 case 'e':
#line 50
          {
#line 50

   edict = optarg;

#line 52
             break;
#line 52
          }
#line 56 "makedict.opt"
	 case 'o':
#line 56
          {
#line 56

   outdir = optarg;

#line 58
             break;
#line 58
          }
#line 62 "makedict.opt"
	 case 'v':
#line 62
          {
#line 62

   verbose++;

#line 64
             break;
#line 64
          }
#line 66 "makedict.opt"
	 case 'h':
#line 66
          {
#line 66

#line 66
		print_help ();
#line 66
                exit (0);
#line 66
	 
#line 66
             break;
#line 66
          }
#line 66 "makedict.opt"
	 case OPTION_USAGE:
#line 66
          {
#line 66

#line 66
		print_usage ();
#line 66
		exit (0);
#line 66
	 
#line 66
             break;
#line 66
          }
#line 66 "makedict.opt"
	 case OPTION_VERSION:
#line 66
          {
#line 66

#line 66
		/* Give version */
#line 66
		print_version(program_version, stdout);
#line 66
		exit (0);
#line 66
         
#line 66
             break;
#line 66
          }

#line 71 "makedict.opt"
        }
#line 71
    }
#line 71
  
#line 71
 }   
#line 71

}
